## dino-im 0.3.1+git20221103.6e37f3f

=== debian/changelog ===
dino-im (0.3.1+git20221103.6e37f3f-1) experimental; urgency=medium

  * New snapshot, use libsoup3

 -- Martin <debacle@debian.org>  Fri, 04 Nov 2022 01:34:31 +0000

dino-im (0.3.0+git20221028.a2f2224-1) experimental; urgency=medium

  * New snapshot

 -- Martin <debacle@debian.org>  Mon, 31 Oct 2022 23:20:07 +0000

dino-im (0.3.0+git20221012.d4c6742-1) experimental; urgency=medium

  * New snapshot

 -- Martin <debacle@debian.org>  Wed, 19 Oct 2022 22:45:02 +0000

dino-im (0.3.0+git20221011.a45280f-1) experimental; urgency=medium

  * Removed libhandy support in favour of GTK4
  * Upstream snapshot (GTK4, message reactions)

  [Stefan Kropp]
  * added d/watch file

 -- Martin <debacle@debian.org>  Tue, 11 Oct 2022 22:17:37 +0000
