=== debian/watch ===
version=4
opts="mode=git,pgpmode=gittag" \
https://github.com/dino/dino.git \
refs/tags/v([\d\.]+)
