## dino-im 0.4.0

=== debian/changelog ===
dino-im (0.4.0-1) unstable; urgency=medium

  * New upstream release, now using GTK4 and libadwaita
    (providing limited mobile support, Closes: #1021684)
    Major new features: Message reactions and replies

 -- Martin <debacle@debian.org>  Tue, 07 Feb 2023 21:13:31 +0000
