## dino-im 0.4.1

=== debian/changelog ===
dino-im (0.4.1-1) unstable; urgency=medium

  * Bug fix and maintenance release, no new features
  * Fix debian/watch

 -- Martin <debacle@debian.org>  Thu, 02 Mar 2023 07:17:50 +0000
