=== debian/changelog ===
dino-im (0.4.2-1) unstable; urgency=medium

  * Maintenance release with fix for CVE-2023-28686 and bug fixes
    (Closes: #1033370)

 -- Martin <debacle@debian.org>  Fri, 24 Mar 2023 19:27:29 +0000
