=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
 	cmake,
 	dh-exec,
 	gettext,
+	libadwaita-1-dev,
 	libgcrypt20-dev,
 	libgee-0.8-dev,
 	libglib2.0-dev,
@@ -16,6 +17,7 @@
 	libgstreamer-plugins-base1.0-dev,
 	libgstreamer1.0-dev,
 	libgtk-4-dev,
+	libicu-dev,
 	libnice-dev,
 	libnotify-dev,
 	libqrencode-dev,
