## dino-im 0.4.2+git20230324.b75b606

=== debian/changelog ===
dino-im (0.4.2+git20230324.b75b606-1) experimental; urgency=medium

  * Upstream snapshot
  * Includes fix for CVE-2023-28686 (Closes: #1033370)

 -- Martin <debacle@debian.org>  Sat, 25 Mar 2023 09:55:40 +0000

dino-im (0.4.1+git20230307.47a0669-1) experimental; urgency=medium

  * Upstream snapshot

 -- Martin <debacle@debian.org>  Sun, 12 Mar 2023 23:16:53 +0000
