## dino-im 0.4.2+git20230501.0bddf9f

=== meson_options.txt ===
option('plugindir', type: 'string', value: 'lib/dino/plugins', description: 'Plugin directory for Dino plugins')
