=== debian/changelog ===
dino-im (0.4.2+git20230501.0bddf9f-1) experimental; urgency=medium

  * Upstream snapshot
  [ John Scott ]
  * Switch the Homepage to dino.im

 -- Martin <debacle@debian.org>  Fri, 05 May 2023 00:03:13 +0000
